function [ coefValue ] = createFit(time_data,real_temper_data_1, func, coefs, cf_method, normalize_on)
%CREATEFIT Create plot of data sets and fits
%   CREATEFIT(TIME_DATA,REAL_TEMPER_DATA_1)
%   Creates a plot, similar to the plot in the main Curve Fitting Tool,
%   using the data that you provide as input.  You can
%   use this function with the same data you used with CFTOOL
%   or with different data.  You may want to edit the function to
%   customize the code and this help message.
%
%   Number of data sets:  1
%   Number of fits:  1

% Data from data set "real_temper_data_1 vs. time_data":
%     X = time_data:
%     Y = real_temper_data_1:
%     Unweighted

% Auto-generated by MATLAB on 02-Dec-2011 17:41:22

% Set up figure to receive data sets and fits
f_ = clf;
figure(f_);
set(f_,'Units','Pixels','Position',[473 113 688 485]);
% Line handles and text for the legend.
legh_ = [];
legt_ = {};
% Limits of the x-axis.
xlim_ = [Inf -Inf];
% Axes for the plot.
ax_ = axes;
set(ax_,'Units','normalized','OuterPosition',[0 0 1 1]);
set(ax_,'Box','on');
axes(ax_);
hold on;

% --- Plot data that was originally in data set "real_temper_data_1 vs. time_data"
time_data = time_data(:);
real_temper_data_1 = real_temper_data_1(:);
h_ = line(time_data,real_temper_data_1,'Parent',ax_,'Color',[0.333333 0 0.666667],...
    'LineStyle','none', 'LineWidth',1,...
    'Marker','.', 'MarkerSize',12);
xlim_(1) = min(xlim_(1),min(time_data));
xlim_(2) = max(xlim_(2),max(time_data));
legh_(end+1) = h_;
legt_{end+1} = 'real_temper_data_1 vs. time_data';

% Nudge axis limits beyond data limits
if all(isfinite(xlim_))
    xlim_ = xlim_ + [-1 1] * 0.01 * diff(xlim_);
    set(ax_,'XLim',xlim_)
else
    set(ax_, 'XLim',[1.4199999999999999, 60.579999999999998]);
end

% --- Create fit "fit 1"
fo_ = fitoptions('method',cf_method,'Normalize',normalize_on);
ok_ = isfinite(time_data) & isfinite(real_temper_data_1);
if ~all( ok_ )
    warning( 'GenerateMFile:IgnoringNansAndInfs',...
        'Ignoring NaNs and Infs in data.' );
end
st_ = [0.98753732056493859 0.58858518322192943 0.18140384603395476 ];
set(fo_,'Startpoint',st_);
ft_ = fittype(func,...
    'dependent',{'y'},'independent',{'x'},...
    'coefficients',coefs);

% Fit this model using new data
cf_ = fit(time_data(ok_),real_temper_data_1(ok_),ft_,fo_);
coefValue = coeffvalues(cf_);
% Alternatively uncomment the following lines to use coefficients from the
% original fit. You can use this choice to plot the original fit against new
% data.
%    cv_ = { -0.80240268157037709, 0.87404361475012438, 26.173139380479743};
%    cf_ = cfit(ft_,cv_{:});

% Plot this fit
h_ = plot(cf_,'fit',0.95);
set(h_(1),'Color',[1 0 0],...
    'LineStyle','-', 'LineWidth',2,...
    'Marker','none', 'MarkerSize',6);
% Turn off legend created by plot method.
legend off;
% Store line handle and fit name for legend.
legh_(end+1) = h_(1);
legt_{end+1} = cf_method;

% --- Finished fitting and plotting data. Clean up.
hold off;
% Display legend
leginfo_ = {'Orientation', 'vertical', 'Location', 'NorthEast'};
h_ = legend(ax_,legh_,legt_,leginfo_{:});
set(h_,'Interpreter','none');
% Remove labels from x- and y-axes.
xlabel(ax_,'');
ylabel(ax_,'');
