

#ifndef __GROUP_INFO_MANAGER_H__
#define __GROUP_INFO_MANAGER_H__

#include "MeetingInfo.h"

typedef int MeetingInfoNum;
typedef int RoomInfoNum;

class GroupInfoManager;
typedef GroupInfoManager* GroupInfoManager_ptr;

#define MAX_MEETING_NUMBER 1000
#define MAX_ROOM_NUMBER 500

class GroupInfoManager{
private:
	MeetingInfo m_rawMeetingArr[MAX_MEETING_NUMBER];
	int m_rawMeetingNumber;

	MeetingInfo_ptr m_meetingArr[MAX_MEETING_NUMBER];
	int m_meetingNumber;
	
	MeetingInfo_ptr m_startTimeArr[MAX_MEETING_NUMBER];
	MeetingInfo_ptr m_endTimeArr[MAX_MEETING_NUMBER];

	RoomInfo m_roomArr[MAX_ROOM_NUMBER];
	int m_roomNumber;

	RoomInfo_ptr m_roomFacilityArr[MAX_ROOM_NUMBER]; //Sort in descending order of facility number

	RoomInfo m_nullRoom;
	MeetingInfo_ptr m_unschedulabeMeetingArr[MAX_MEETING_NUMBER];	//For the ones can not be scheduled;
	int m_unschedulableMeetingNumber;
	
	
public:
	GroupInfoManager():m_rawMeetingNumber(0), m_meetingNumber(0),m_roomNumber(0), m_unschedulableMeetingNumber(0){};

	MeetingInfo_ptr addMeetingInfo(MeetingInfo& meetingInfo);

	MeetingInfoNum addUnscheduledMeeting(MeetingInfo_ptr meetingInfo);

	MeetingInfo_ptr getMeetingInfo(MeetingInfoNum meetingNum);

	RoomInfo_ptr addRoomInfo(RoomInfo& roomInfo);

	RoomInfo_ptr getRoomInfo(RoomInfoNum roomNum);

	RoomInfo_ptr getRoomInfoByName(const char* roomName);
	
	MeetingInfo_ptr* meetingEndTimeArr(){return m_endTimeArr;}
	int meetingNum(){return m_meetingNumber;}
	RoomInfo* roomInfoArr(){return m_roomArr;}
	int roomNum(){return m_roomNumber;}
	
	int sort();
	
	int recoverRawSchedule();
	
	int optimalSchedule();

	int energyAwareFacilitySchedule();

	int bestFitSchedule();

	int timeUnrestrictedSchedule();
	
	int timeUnrestrictedFacilitySchedule();
	
	int resetSchedule();

	float calculateEnergy();
	float calculateMinEnergy();
	float calculateMaxEnergy();

	MeetingInfo_ptr* unscheduledMeeting(){return m_unschedulabeMeetingArr;}
	int unscheduledMeetingNum(){return m_unschedulableMeetingNumber;}
	float generateEnergyPlusInput(float* originArr, FILE* fpZone, FILE* fpSurface, FILE* fpHVAC, FILE* fpZoneHVACmap, FILE* fpSchedule, FILE* fpScheduleDummy, FILE* fpScheduleWOR);

	
};

#endif
